''  *** COMPILED WITH PropBasic VERSION 0.00.16  10/14/2009 ***


CON                                                          'DEVICE P8X32A, XTAL1, PLL16X
  _ClkMode = XTAL1 + PLL16X                                 

  _XInFreq =   5000000                                       'FREQ 80_000_000


                                                             '' Define HUB variables
' VAR BYTE vidMem[6144]                                      'vidMem  HUB BYTE(6144) = 0


                                                             '' Define DATA (DATA, WDATA, LDATA)

                                                             '' Define TASKs
OBJ MonoVid: "MonoVid.spin"                                  'MonoVid  TASK


                                                             '' Define variables (LONGs only)
' X      VAR LONG                                            'X      VAR LONG

' xDir   VAR LONG                                            'xDir   VAR LONG

' Y      VAR LONG                                            'Y      VAR LONG

' yDir   VAR LONG                                            'yDir   VAR LONG


                                                             '' Define Subroutines
' XPlot   SUB 2                                              'XPlot   SUB 2


PUB __Program                                                'PROGRAM Start
  MONOVID.Init(@__DATASTART)                                
  CogNew(@__Init, @__DATASTART)                             
                                                            
DAT                                                         
                org         0                               
__Init                                                      
                mov         dira,__InitDirA                 
                mov         outa,__InitOutA                 
                jmp         #Start                          


Start                                                        'Start:

                mov         __temp1,cnt                      '  PAUSE 100 ' Give tasks time to start
                adds        __temp1,_1mSec                  
                mov         __temp2,#100                    
__L0001                                                     
                waitcnt     __temp1,_1mSec                  
                djnz        __temp2,#__L0001                


                mov         X,#0                             '  X = 0

                mov         Y,#0                             '  Y = 0

                mov         xDir,#1                          '  xDir = 1

                mov         yDir,#1                          '  yDir = 1


__DO_1                                                       '  DO

                mov         __param1,X                       '    XPlot x, y
                mov         __param2,Y                      
                call        #XPlot                          

                adds        X,xDir                           '    x = x + xDir

                cmps        X,#255 WZ, WC                    '    IF x > 255 THEN
    IF_BE       jmp         #__ELSE_1                       

                neg         xDir,xDir                        '      xdir = -xdir

                adds        X,xDir                           '      x = x + xdir

__ELSE_1                                                     '    ENDIF
__ENDIF_1                                                   

                cmps        X,#0 WZ, WC                      '    IF x < 0 THEN
    IF_AE       jmp         #__ELSE_2                       

                neg         xDir,xDir                        '      xdir = -xdir

                adds        X,xDir                           '      x = x + xdir

__ELSE_2                                                     '    ENDIF
__ENDIF_2                                                   

                adds        Y,yDir                           '    y = y + yDir

                cmps        Y,#190 WZ, WC                    '    IF Y > 190 THEN
    IF_BE       jmp         #__ELSE_3                       

                neg         yDir,yDir                        '      yDir = -yDir

                adds        Y,yDir                           '      y = y + yDir

__ELSE_3                                                     '    ENDIF
__ENDIF_3                                                   

                cmps        Y,#0 WZ, WC                      '    IF Y < 0 THEN
    IF_AE       jmp         #__ELSE_4                       

                neg         yDir,yDir                        '      yDir = -yDir

                adds        Y,yDir                           '      y = y + yDir

__ELSE_4                                                     '    ENDIF
__ENDIF_4                                                   


                mov         __temp1,cnt                      '    PAUSEUS 50
                adds        __temp1,#80                     
                mov         __temp2,#50                     
__L0002                                                     
                waitcnt     __temp1,#80                     
                djnz        __temp2,#__L0002                

                jmp         #__DO_1                          '  LOOP
__LOOP_1                                                    

                jmp         #$                               'END


XPlot                                                        'SUB XPlot ' X, Y

                mov         __PARAM4,#vidMem_ofs             '  GetAddr VidMem, __param4
                add         __PARAM4,par                    

                shl         __PARAM2,#5                      '  __param2 = __param2 << 5 ' 32 bytes per row

                adds        __PARAM4,__PARAM2                '  __param4 = __param4 + __param2


                mov         __PARAM2,__PARAM1                '  __param2 = __param1 >> 3 ' x div 8
                shr         __PARAM2,#3                     

                adds        __PARAM4,__PARAM2                '  __param4 = __param4 + __param2


                rdbyte      __PARAM2,__PARAM4                '  RDBYTE __param4, __param2

                and         __PARAM1,#7                      '  __param1 = __param1 & 7

                mov         __PARAM3,#1                      '  __param3 = 1 << __param1
                shl         __PARAM3,__PARAM1               

                xor         __PARAM2,__PARAM3                '  __param2 = __param2 XOR __param3

                wrbyte      __PARAM2,__PARAM4                '  WRBYTE __param4, __param2

XPlot_ret                                                    'ENDSUB
                ret                                         
                                                            



'**********************************************************************
__InitDirA       LONG %00000000_00000000_00000000_00000000
__InitOutA       LONG %00000000_00000000_00000000_00000000
_1mSec           LONG 80000

__REMAINDER
__TEMP1          RES 1
__TEMP2          RES 1
__TEMP3          RES 1
__TEMP4          RES 1
__TEMP5          RES 1
__PARAM1         RES 1
__PARAM2         RES 1
__PARAM3         RES 1
__PARAM4         RES 1
__PARAMCNT       RES 1
X                RES 1
xDir             RES 1
Y                RES 1
yDir             RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  vidMem_ofs                       = 0

' TASK MonoVid                                               'TASK MonoVid


DAT
__DATASTART
vidMem           BYTE 0[6144]
